/********************************************
Copyright 2010 by Michael Kiermaier, Bayreuth
********************************************/

//for static maps
#ifndef _MAP_HPP
#define _MAP_HPP

#include <boost/mpl/vector.hpp>
#include <boost/mpl/size.hpp>
#include <boost/mpl/at.hpp>
#include "set.hpp"

template<typename Args, typename Res> 
struct Map {
    //models a Map X x Y x Z x ... -> R, where X, Y, Z, ..., R are Sets.
    //should contain a function Element<R> operator()(Element<X> const &, Element<Y> const &, Element<Z> const &, ...) const;
    //Args is assumed to be a boost::mpl::vector containing [X,Y,Z,...].
    //Res is assumed to be the Set-Type R.
    typedef Args ArgumentTypes;
    typedef typename boost::mpl::at_c<Args, 0>::type ArgumentType1;
    typedef typename boost::mpl::at_c<Args, 1>::type ArgumentType2;
    typedef typename boost::mpl::at_c<Args, 2>::type ArgumentType3;
    typedef Res ResultType;

    typedef Element<Res> result_type; //for stl compatibility
    template<typename Arg> struct sig { //for boost::lambda compatibility
	typedef Res type;
    };
    typedef typename boost::mpl::size<Args>::type NumberOfArguments;
};

#endif
