/********************************************
Copyright 2010 by Michael Kiermaier, Bayreuth
********************************************/

#ifndef _MATH_HELPER_HPP
#define _MATH_HELPER_HPP

#include <vector>

namespace mathHelper {
    inline unsigned int pow(unsigned int const base, unsigned int const exp) {
	unsigned int res = 1;
	for(unsigned int i = 0; i < exp; i++) {
	    res *= base;
	}
	return res;
    }

    inline unsigned int gcd(unsigned int a, unsigned int b) {
	unsigned int tmp;
	while(a != 0) {
	    tmp = a;
	    a = b % a;
	    b = tmp;
	}
	return b;
    }

    inline unsigned int lcm(unsigned int a, unsigned int b) {
	return (a / gcd(a,b)) * b;
    }

    inline unsigned int factorial(unsigned int n) {
	unsigned int res = 1;
	for( ; n > 1; --n) {
	    res *= n;
	}
	return res;
    }

    unsigned int gaussianBinomialCoefficient(unsigned int n, unsigned int k, unsigned int q);
    unsigned int gaussianBinomialCoefficient(std::vector<unsigned int> const & lambda, std::vector<unsigned int> const & mu, unsigned int q);
}

#endif
