/********************************************
Copyright 2010 by Michael Kiermaier, Bayreuth
********************************************/

#ifndef _ROOT_HPP
#define _ROOT_HPP

#include <boost/mpl/bool.hpp>
//dummy Root type serving as root in template specializations.
struct Root;

template<typename T, typename Func = Root> 
//The 'typename T' parameter is necessary for function objects 'Func' that depend on more than one type.
//For example, Action<S,X> depends on 'S' and 'X', so we can define
//Base<S, Action<S,X> > and <Base<X, Action<S, X> >
//Notice that if S and X are the same type, there is no way to distinguish them by Base<...>.
//Hopefully there wont show up a situation where we would like to do that.
struct Base : public Base<T, Root> {};

template<typename T>
struct Base<T, Root> {
    typedef Root type;
};

struct TypeConversionByCast;
struct TypeConversionByImplementation;
typedef TypeConversionByImplementation TypeConversionDefault;

template<typename T, typename Func>
struct TypeConversion {
    typedef TypeConversionDefault type;
};

#endif
