/********************************************
Copyright 2010 by Michael Kiermaier, Bayreuth
********************************************/

#ifndef _VALUE_WRAPPER_POLICY
#define _VALUE_WRAPPER_POLICY

template<typename T, T val>
struct ValueWrapperByTemplateParameter {
    typedef T ValueType;
    static T value() {
	return val;
    }
};

template<typename T, typename id>
class ValueWrapperByInitFunction {
    public:
	typedef T ValueType;
    private:
	static T val;
    public:
	static T value() {
	    return val;
	}

	static void init(T const & val_in) {
	    val = val_in;
	}
};

template<typename T, typename id>
T ValueWrapperByInitFunction<T, id>::val;

#endif
