/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#include "columnHashTable.h"

ColumnHashTable::ColumnHashTable(unsigned int _n, unsigned int maxSize){
    this->maxIndex=0;
    this->currEntries=0;
    this->maxEntries=maxSize/sizeof(HASH_TYPE);
    this->n=_n;
    this->columnHash=new std::set<HASH_TYPE>[_n+1];
}

ColumnHashTable::~ColumnHashTable(){
    delete[] this->columnHash;
}

void ColumnHashTable::clear(){
    for (unsigned int i=0; i<=this->n; i++){
	this->columnHash[i].clear();
    }
    this->currEntries=0;
}

void ColumnHashTable::insert(const HASH_TYPE& val, unsigned int _n){
    if (this->currEntries<=this->maxEntries){
	this->currEntries++;
	this->columnHash[_n].insert(val);
	this->maxIndex=(std::max)(this->maxIndex,_n);
    }
    else{
	this->columnHash[this->maxIndex].erase(this->columnHash[this->maxIndex].begin());
	this->columnHash[_n].insert(val);
	if (_n>=this->maxIndex){
	    this->maxIndex=(std::max)(this->maxIndex,_n);
	}
	else{
    	    for (int i=(int)this->maxIndex; i>=0; i--){
		if (!this->columnHash[i].empty()){
		    break;
		}
		this->maxIndex--;
    	    }
	}
    }
}

bool ColumnHashTable::find(const HASH_TYPE& val, unsigned int _n){
    std::set<HASH_TYPE>::iterator iter=this->columnHash[_n].find(val);
    return (iter!=this->columnHash[_n].end());
}

