/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef DEFS_H
#define DEFS_H

#include <utility>
#include <map>

#ifdef GNU
    #ifndef NULL
	#define NULL 0
    #endif
#endif

#ifdef LINUX
    #define MKDIRCALL "mkdir -p"
#else
    #define MKDIRCALL "mkdir"
#endif

#define MAX_PERIOD 32
#define MAX_WEIGHT 127
#define MAX_LENGTH 1024
#define MAX_U_ARCS 1024

typedef unsigned char WEIGHT_TYPE;
typedef unsigned int WEIGHT_SUM;
typedef unsigned int COLUMN_NO;
typedef unsigned int MESSAGE_NO;
typedef unsigned int HEIGHT;
typedef unsigned int PERIOD;
typedef long long EVAL_TYPE;
typedef long long HASH_TYPE;
typedef std::pair<COLUMN_NO,std::pair<EVAL_TYPE, HASH_TYPE> > NUMBER_EVAL_PAIR;

#define MINUS_INFTY_DB -1.0e100
#define MINUS_INFTY_LL -0x7999999999999999LL
#define EVAL_SHIFT 1.0e14

#define DEFAULT_ALTER_BOUND 1.5
#define DEFAULT_TIMEOUT 1.0e100
#define DEFAULT_EVALHASH_SIZE 1000000000
#define DEFAULT_COLUMNHASH_SIZE 1000000000

//search RESULTS
#define NOSOLUTION_COMPLETE 1
#define NOSOLUTION_TIMEOUT  2
#define FOUNDSOLUTION       3

//output levels
#define OUTPUT_ALWAYS 10
#define OUTPUT_FEW 20
#define OUTPUT_NORMAL 30
#define OUTPUT_DEBUG 40
#define OUTPUT_ALL 50

//error numbers thrown by functions
#define ERROR_CONVSTR2ELEMENT 1
#define ERROR_CONVGM2NUMBERVEC 2
#define ERROR_CONVCOL2NUMBER 3
#define ERROR_STREAM2DBENTRY 4
#define ERROR_IMPORTFILE 5
#define ERROR_CREATEHMTLFILES 5

//numbers for the different weights
#define WEIGHT_UNDEFINED 0
#define WEIGHT_HAMWEIGHT 1
#define WEIGHT_HOMWEIGHT 2

class comp_NUMBER_EVAL_PAIR{
    public:
    bool operator()(const NUMBER_EVAL_PAIR& a, const NUMBER_EVAL_PAIR& b){
        return a.second>b.second;
    }
};
#endif

