/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#include "evalHashTable.h"

EvalHashTable::EvalHashTable(unsigned int _n, unsigned int maxSize){
    this->maxIndex=0;
    this->currEntries=0;
    this->maxEntries=maxSize/sizeof(std::pair<HASH_TYPE,HASH_MAP_SECOND_VAL>);
    this->n=_n;
    this->evalHash=new EVALHASHTYPE[_n+1];
}

EvalHashTable::~EvalHashTable(){
    delete[] this->evalHash;
}

void EvalHashTable::clear(){
    for (unsigned int i=0; i<=this->n; i++){
	this->evalHash[i].clear();
    }
    this->currEntries=0;
}

void EvalHashTable::insert(const std::pair<HASH_TYPE,HASH_MAP_SECOND_VAL>& val, unsigned int _n){
    if (this->currEntries<=this->maxEntries){
	this->currEntries++;
	this->evalHash[_n].insert(val);
	this->maxIndex=(std::max)(this->maxIndex,_n);
    }
    else{
	this->evalHash[this->maxIndex].erase(this->evalHash[this->maxIndex].begin());
	this->evalHash[_n].insert(val);
	if (_n>=this->maxIndex){
	    this->maxIndex=(std::max)(this->maxIndex,_n);
	}
	else{
    	    for (int i=(int)this->maxIndex; i>=0; i--){
		if (!this->evalHash[i].empty()){
		    break;
		}
		this->maxIndex--;
    	    }
	}
    }
}

bool EvalHashTable::find(const HASH_TYPE& hashVal, unsigned int _n, EVALHASHTYPE::iterator& iter){
    iter=this->evalHash[_n].find(hashVal);
    return (iter!=this->evalHash[_n].end());
}

