/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef EVAL_HASH_TABLE_H
#define EVAL_HASH_TABLE_H

#include "defs.h"

#ifdef HTMLTREE_HASHLINKS
    typedef std::pair<bool,NODE_NUMBER> HASH_MAP_SECOND_VAL; 
#else 
    typedef bool HASH_MAP_SECOND_VAL; 
#endif
typedef std::map<HASH_TYPE, HASH_MAP_SECOND_VAL> EVALHASHTYPE;

class EvalHashTable{
public:
    EvalHashTable(unsigned int _n, unsigned int maxSize);
    ~EvalHashTable();
    void clear();
    void insert(const std::pair<HASH_TYPE,HASH_MAP_SECOND_VAL>& val, unsigned int _n);
    bool find(const HASH_TYPE& val, unsigned int _n, EVALHASHTYPE::iterator& iter);

private:
    unsigned int n;
    unsigned int currEntries;
    unsigned int maxEntries;
    unsigned int maxIndex;
    EVALHASHTYPE* evalHash;
};
#endif

