/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef HAMMING_WEIGHT_TABLE_HPP
#define HAMMING_WEIGHT_TABLE_HPP

#include "defs.h"
#include "./Ringe/mathHelper.hpp"
#include "abstractWeightTable.hpp"

template <class CHAINRING> class HammingWeightTable : AbstractWeightTable<CHAINRING>{
    public:
    void init();
    WEIGHT_TYPE get_weight(PERIOD);
    WEIGHT_TYPE max_weight();
    std::string name();
};

template <class CHAINRING>
void HammingWeightTable<CHAINRING>::init(){
}

template <class CHAINRING>
WEIGHT_TYPE HammingWeightTable<CHAINRING>::get_weight(PERIOD h){
    if (h==0){
	return 0;
    }
    return 1;
}

template <class CHAINRING>
WEIGHT_TYPE HammingWeightTable<CHAINRING>::max_weight(){
    return 1;
}

template <class CHAINRING>
std::string HammingWeightTable<CHAINRING>::name(){
    return std::string("hamming weight");
}

#endif

