/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef HTML_TREE_CREATOR_H
#define HTML_TREE_CREATOR_H

#include <string>
#include "defs.h"

#define NODES_PER_DIRECTORY 1000

typedef long long NODE_NUMBER;
typedef long long TIME_TYPE;

class HTMLTreeCreator{
public:
    HTMLTreeCreator();
    ~HTMLTreeCreator();
    void newRootNode(std::string path, NODE_NUMBER maxN, TIME_TYPE t);
    void addEdge(NODE_NUMBER from, NODE_NUMBER to, std::string comment, TIME_TYPE t);
    void addComment(NODE_NUMBER node, std::string comment, TIME_TYPE t);
private:
    std::string getDirName(NODE_NUMBER);
    std::string createDir(NODE_NUMBER);
    std::string currentPath;
    NODE_NUMBER maxNodes;
    unsigned int dirNumber;
    bool* directoryCreated;
};

#endif

