/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef NEIGHBOURHOOD_CLASS_H
#define NEIGHBOURHOOD_CLASS_H

#include "defs.h"

struct NeighbourhoodClass{
    PERIOD distance;
    std::vector<NeighbourhoodClass*> children;
    HASH_TYPE hash;
    unsigned int classSize;

    NeighbourhoodClass(){
	classSize=0;
    }

    ~NeighbourhoodClass(){
	unsigned int size=this->children.size();
	for (unsigned int i=0; i<size; i++){
	    delete this->children[i];
	}
    }

    void setChildren(std::vector<NeighbourhoodClass*>& v){
	this->children=v;
	unsigned int sizeSum=0;
	unsigned int size=this->children.size();
	for (unsigned int i=0; i<size; i++){
	    sizeSum+=this->children[i]->classSize;
	}
	classSize=sizeSum;
    }

    void resetHash(){
	this->hash=0;
	unsigned int size=this->children.size();
	for (unsigned int i=0; i<size; i++){
	    this->children[i]->resetHash();
	}
    }

    HASH_TYPE getHash(){
	unsigned int size=this->children.size();
	if (this->distance&1){
	    if (size==0){
		return (this->hash);
	    }
    	    for (unsigned int i=0; i<size; i++){
		this->hash+=this->children[i]->getHash();
	    }
	}
	else{
    	    for (unsigned int i=0; i<size; i++){
		this->hash+=this->children[i]->getHash();
	    }
	}
	return this->hash;
    }
};

#endif

