/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef NUMBER_LIST_ENTRY_H
#define NUMBER_LIST_ENTRY_H

#include "defs.h"

struct NumberListEntry{
    unsigned int nr;
    NumberListEntry* previousEntry;
    NumberListEntry* nextEntry;
    NumberListEntry* header;
    void undoRemove(){
	this->previousEntry->nextEntry=this;
	this->nextEntry->previousEntry=this;
    }
    void undoRemoveToEnd(){ //this has to be used if the order has been switched in between
	this->nextEntry=this->header;
	this->previousEntry=this->header->previousEntry;
	this->previousEntry->nextEntry=this;
	this->header->previousEntry=this;
    }
    void undoRemoveToFront(){ //this has to be used if the order has been switched in between
	this->previousEntry=this->header;
	this->nextEntry=this->header->nextEntry;
	this->nextEntry->previousEntry=this;
	this->header->nextEntry=this;
    }
    void removeFromList(){
	this->previousEntry->nextEntry=this->nextEntry;
	this->nextEntry->previousEntry=this->previousEntry;
    }
    void sortToFront(){
	this->removeFromList();
	this->undoRemoveToFront();
    }
};

#endif

