/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef TYPE_SECTION_HPP
#define TYPE_SECTION_HPP

#include "defs.h"
#include "messageType.hpp"
#include "numberListEntry.h"

template <class CHAINRING>
struct TypeSection{
public: 
    TypeSection(MessageType<CHAINRING> const&, std::vector<MESSAGE_NO>&); 
    ~TypeSection(); 
    MessageType<CHAINRING> messageType;
    NumberListEntry* messages;
};

template <class CHAINRING>
TypeSection<CHAINRING>::TypeSection(MessageType<CHAINRING> const& m, std::vector<MESSAGE_NO>& v){
    this->messageType=m;
    unsigned int size=v.size();
    this->messages=new NumberListEntry[size+1];
    this->messages[0].nr=0xFFFFFFFF;
    this->messages[0].nextEntry=&this->messages[1];
    this->messages[0].previousEntry=&this->messages[size];
    this->messages[0].header=this->messages;
    for (unsigned int i=1; i<size; i++){
	this->messages[i].nr=v[i-1];
	this->messages[i].nextEntry=&this->messages[i+1];
	this->messages[i].previousEntry=&this->messages[i-1];
        this->messages[i].header=this->messages;
    }	
    this->messages[size].nr=v[size-1];
    this->messages[size].previousEntry=&this->messages[size-1];
    this->messages[size].nextEntry=&this->messages[0];
    this->messages[size].header=this->messages;
};

template <class CHAINRING>
TypeSection<CHAINRING>::~TypeSection(){
    if (this->messages!=NULL){
	delete[] this->messages;
    }
}

#endif

