/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#include "../h/CommonRoutines.h"
#include "../h/Log.h"

#include <string>
#include <sstream>
#include <cstdlib>

using namespace std;

void convertKMMCodeToProblemString(stringstream& inf, stringstream& of, int n, int d){
	string incidenceMatrix;
	string orbitsizes;
	stringstream rhs;
	string s;

	of.str("");
	of.clear();
	rhs<<" [0,"<<n-d<<"]\n";
	int state=0;
	int rows=0;
	int cols=0;
	bool openBracket=false;
	while(!inf.eof()){
		getline(inf,s);
		size_t t2=s.find("numberoforbits = ");
		if (t2!=string::npos){
			cols=atoi(s.substr(t2+17).c_str());
		}
		switch(state){
				case 0:
					if (s.find("orbitsizes = [")!=string::npos){
						size_t t1;
						s=ReplaceString(string(","),string(" "),s);
						s=ReplaceString(string("\n"),string(""),s);
						t1=s.find("[");
						if (s.find("]")!=string::npos){
							s=ReplaceString(string("]"),string(""),s);
							state=2;
						}
						else{
							state=1;
						}
						orbitsizes+=s.substr(t1+1,s.length()-t1-1);
					}
					break;

				case 1:
					s=ReplaceString(string(","),string(" "),s);
					s=ReplaceString(string("\n"),string(""),s);
					if (s.find("]")!=string::npos){
						s=ReplaceString(string("]"),string(""),s);
						state=2;
					}
					orbitsizes+=s;
					break;

				case 2:
					if (s.find("(point)-(hyperplane) incidencematrix =")!=string::npos){
						state=3;
					}
					break;

				case 3:
					if (s.find(string("(point)-(line) incidencematrix"))!=string::npos){
						state=4;
						break;
					}
					if (s.find(string("["))!=string::npos){
						openBracket=true;
						s=ReplaceString(string("["),string(""),s);
					}
					s=ReplaceString(string("\n"),string(""),s);
					s=ReplaceString(string(":"),string(" "),s);
					size_t t;
					if (openBracket){
						if ((t=s.find("]"))!=string::npos){
							openBracket=false;
							s=s.substr(0,t);
							s+=rhs.str();
							rows++;
						}			
						incidenceMatrix+=s;
					}
					break;
		}
	}
	of<<rows<<" "<<cols<<std::endl;
	of<<incidenceMatrix;
	of<<orbitsizes<<"["<<n<<","<<n<<"]"<<std::endl;
}

