/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#include "../h/EvalTable.h"

EvalTable::EvalTable(){
    this->mem_allocated=false;
}
EvalTable::~EvalTable(){
    this->freeMemory();
}

void EvalTable::freeMemory(){
    if (mem_allocated){
	delete[] this->entry;
	this->mem_allocated=false;
    }
}

void EvalTable::init(int l, int u, EVAL_TYPE rv_llimit, EVAL_TYPE rv_ulimit){
    this->l_limit=l;
    this->u_limit=u;
    this->retval_llimit=rv_llimit;
    this->retval_ulimit=rv_ulimit;
    if (l<=u){
	this->entry=new EVAL_TYPE[u-l+1];
	this->mem_allocated=true;
    }
    else{
	this->entry=0;
    }
}

int EvalTable::get_llimit(){
    return this->l_limit;
}

int EvalTable::get_ulimit(){
    return this->u_limit;
}

EVAL_TYPE EvalTable::get_val(int i){
    if (i<this->l_limit){
	return retval_llimit;
    }
    if (i>this->u_limit){
	return retval_ulimit;
    }
    return this->entry[i-this->l_limit];
}

void EvalTable::set_val(int i, EVAL_TYPE d){
    if (i>=this->l_limit && i<=this->u_limit){
	this->entry[i-this->l_limit]=d;
    }
}

