/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#include "../h/FileProblemConstructor.h"
#include "../h/CommonRoutines.h"
#include "../h/Log.h"
#include "../h/Solver.h"
#include <iostream>
#include <fstream>

FileProblemConstructor::FileProblemConstructor(string f) : filename(f) {
}

FileProblemConstructor::~FileProblemConstructor(){	
}

void FileProblemConstructor::setFile(string name){
	this->filename=name;
}

string FileProblemConstructor::getFile(){
	return this->filename;
}

Problem* FileProblemConstructor::getProblem(){
    ifstream f;

    f.open(this->filename.c_str());
    Problem* p=NULL;
    if (f.is_open()){
	stringstream s;
	string l;
	while(!f.eof()){
	    getline(f,l);
	    s<<l<<std::endl;
	}
	p=constructProblemFromSStream(s);
	f.close();
    }
    else{
	stringstream s;
	s<<"Error in FileProblemConstructor::getProblem: could not open file!"<<std::endl;
	writeToConsole(s);
	quitSolver(ERROR_OCCURED);
    }
    return p;
}	
