/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#include "../h/Solver.h"
#include "../h/KMMConstructor.h"
#include "../h/Converter.h"
#include "../h/CommonRoutines.h"
#include "../h/Log.h"
#include "../h/Defs.h"

#include <fstream>
#include <cstdlib>

KMMConstructor::KMMConstructor(string file, inequationType t, sum_of_entries _n, sum_of_entries _rhs){
    this->filename=file;
    this->iet=t;
    this->rhs=_rhs;
    this->n=_n;
}

KMMConstructor::~KMMConstructor(){	
}

Problem* KMMConstructor::getProblem(){
    Problem* p=NULL;
    ifstream inf;
    inf.open(this->filename.c_str());
    if (inf.is_open()){
	stringstream data;
	string line;
	unsigned int rows,cols;

	//Dimensionen einlesen
	getline(inf,line);
	size_t t=0;
	while(t<line.size() && line[t]!=' '){t++;}
	rows=atoi(line.substr(0,t).c_str());
	while(t<line.size() && line[t]!=' '){t++;}
	while(t<line.size() && line[t]==' '){t++;}
	cols=atoi(line.substr(t).c_str());

	data<<rows<<" "<<cols<<std::endl;
	unsigned int counter=0;
	while(!inf.eof()){
	    getline(inf,line);
	    data<<line;
	    if (counter<rows){
		switch(this->iet){
		    case IEQ_TYPE_EQ:
			data<<" ["<<this->rhs<<","<<this->rhs<<"]"<<std::endl;
			break;
		    case IEQ_TYPE_GE:
			data<<" ["<<this->rhs<<","<<this->n<<"]"<<std::endl;
			break;
		    case IEQ_TYPE_LE:
			data<<" [0"<<","<<this->rhs<<"]"<<std::endl;
			break;
		}
	    }
	    else{
		data<<" ["<<this->n<<","<<this->n<<"]"<<std::endl;
		break;
	    }
	    counter++;
	}
	p=constructProblemFromSStream(data);
	inf.close();
    }
    else{
	stringstream error;
	error<<"Error in KMMConstructor::getProblem(): could not open "<<this->filename.c_str()<<" ."<<std::endl;
	writeToConsole(error);
	quitSolver(ERROR_OCCURED);
    }
    return p;
}
