/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#include "../h/Log.h"
#include "../h/Solver.h"
#include "../h/Defs.h"
#include "../h/TimeManager.h"
#include <string>
#include <iostream>
#include <fstream>

string logName="";
ofstream logfile;
bool logging=false;

void writeToConsole(stringstream& s){
	if (logging && logfile.is_open()==false){
		logfile.open(logName.c_str());
	}
	stringstream s2;
	s2<<s.str();
	if (logging){
		logfile<<s2.str()<<flush;
	}
	cout<<s2.str()<<flush;
}

void closeLog(){
	if (logfile.is_open()){
		logfile.close();
	}
}

void setLogging(std::string newLogname){
	if (logName!=""){
		closeLog();
	}		
	logName=newLogname;
	if (newLogname==""){
		logging=false;
	}
	else{
		logging=true;
	}
}

bool getLogging(){
	return logging;
}

