/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#include "../h/Problem.h"

int Problem::getUpperVarBound(){
    return this->upperVarBound;
}

void Problem::setUpperVarBound(int newBound){
    this->upperVarBound=newBound;
}

string Problem::getAsString(){
    string s=this->matrix.getAsString();
    char* buffer=new char[10+this->matrix.cols*MAX_ENTRY_LENGTH];
    unsigned int offset=0,c;
    offset+=sprintf(buffer+offset,"\n");
    for (c=0; c<this->matrix.cols; c++){
	offset+=sprintf(buffer+offset,"%2i ",this->controlRow[c]);
    }
    offset+=sprintf(buffer+offset," in [%2i,%2i]\n",this->CRLowerBound,this->CRUpperBound);
    if (this->getUpperVarBound()!=NO_UPPER_BOUND){
	offset+=sprintf(buffer+offset,"upperVarBound = %u\n",this->getUpperVarBound());		
    }
    s+=string(buffer);	
    delete[] buffer;
    return s;
}

void Problem::clear(){
    matrix.clear();
    if (controlRow!=NULL){
	delete[] controlRow;
    }
}
