/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#include "../h/Thread.h"

#ifdef LINUX
#include <pthread.h>
#else
#include <windows.h>
#include <process.h>
#endif

#ifdef LINUX
void *ThreadRunFunction(void* pvoid)
{
    ((Thread*)pvoid)->publicRun();
    return 0;
};

#else
extern "C"
{
    VOID ThreadRunFunction(PVOID pvoid)
    {
	((Thread*)pvoid)->publicRun();
    };
};
#endif

Thread::Thread() :
bLock(false)
{
}

Thread::~Thread()
{
}

void Thread::startThread()
{
#ifdef LINUX
    pthread_t thread;
    pthread_create(&thread, 0, ThreadRunFunction, this);
#else
    ::_beginthread((void (__cdecl *)(void *))ThreadRunFunction,0,(void*)this);
#endif
}

void Thread::publicRun()
{
    if (!bLock)
    {
	run();
	bLock=true;
    }
}
