/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#include "../h/TimeManager.h"

timeval TimeManager::getCurrentTime(){
	timeval t;
#ifdef LINUX
	gettimeofday(&t,0);
#endif
#ifdef WIN32
	_timeb time;
	_ftime(&time);
	t.tv_sec=(long)time.time;
	t.tv_usec=time.millitm*1000;
#endif
	return t;
}

timeval TimeManager::startTime;

double TimeManager::getTimeDiff(timeval const & et, timeval const & st){
	double result=et.tv_sec+et.tv_usec/1000000.0;
	result-=st.tv_sec+st.tv_usec/1000000.0;
	return result;
}

void TimeManager::setStartTimer(){
	startTime=getCurrentTime();
}

double TimeManager::timeSinceStart(){
	return getTimeDiff(getCurrentTime(),startTime);
}

void TimeManager::waitSomeTime(unsigned int units){
	#ifdef LINUX
		timespec t;
		t.tv_sec=0; //seconds
		t.tv_nsec=1000000*units; //nanoseconds
		nanosleep(&t,0);
	#else //windows version
		::Sleep(units);
	#endif
}
