/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#include "../h/hashTable.h"

HashTable::HashTable(unsigned long long maxSize){
    this->currEntries=0;
    this->size=maxSize/sizeof(unsigned long long);
    unsigned long long pow=1;
    while(pow<this->size){
	pow*=2;
    }
    if (pow>this->size){
	pow/=2;
    }
    this->size=pow;
    if (this->size==0){
	this->size=1;
    }
    this->entries=new unsigned long long[this->size];
    this->mod=this->size-1;
    this->clear();
}

HashTable::~HashTable(){
    delete[] this->entries;
}

void HashTable::clear(){
    for (unsigned long long i=0; i<this->size; i++){
	this->entries[i]=HASHTABLE_DEFAULT_ENTRY;
    }
    this->currEntries=0;
}

void HashTable::insert(const unsigned long long& val){
    unsigned long long key=(val&this->mod);
    if (this->entries[key]==HASHTABLE_DEFAULT_ENTRY){
	this->currEntries++;
    }
    this->entries[key]=val;
}

bool HashTable::find(const unsigned long long& val){
    unsigned long long key=(val&this->mod);
    return (this->entries[key]==val);
}

unsigned long long HashTable::getCurrentSize(){
    return this->currEntries*sizeof(unsigned long long);
}
