/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#include "../h/solveThread.h"

SolveThread::SolveThread() : thread_running(false){
}

void SolveThread::solveProblem(Problem* p, vector<PCStruct>& pc, AbstractSolveAlgorithm* alg, double timeout){
    this->thread_solution=NULL;
    this->thread_running=true;
    this->thread_p=p;
    this->thread_pc=pc;
    this->thread_alg=alg;
    this->thread_time=timeout;
    this->startThread();
}

int* SolveThread::getSolution(){
    return this->thread_solution;
}

std::string SolveThread::getTerminationInfo(){
    return this->thread_alg->getTerminationInfo();
}

bool SolveThread::getRunning(){
    return this->thread_running;
}

void SolveThread::run(){
    this->thread_solution=this->thread_alg->solveProblem(this->thread_p,this->thread_pc,this->thread_time);
    this->thread_running=false;
}
