/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef ABSTRACT_EVALUATOR_H
#define ABSTRACT_EVALUATOR_H

#include "Problem.h"
#include "NumberListEntry.h"
#include "RowListEntry.h"
#include "commonStructs.h"
#include "twoDimArray.hpp"
#include <vector>

class AbstractEvaluator{
public:
	virtual Problem* getProblem()=0;
	virtual void setProblem(Problem*)=0;
	virtual EVAL_TYPE getEvaluation(unsigned int c, RowListEntry* relevantRows, unsigned int CRPhase, sum_of_entries currentCR)=0;
	virtual bool getRowIntervals(RowIntervalTable** rivt, bool* rivtAlloc)=0;
};
#endif
