/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef ABSTRACT_SOLVE_ALGORITHM_H
#define ABSTRACT_SOLVE_ALGORITHM_H

#include "Problem.h"
#include "PCStruct.h"
#include <vector>
#include <string>


using namespace std;

class AbstractSolveAlgorithm{
public:
	virtual ~AbstractSolveAlgorithm();
	virtual int* solveProblem(Problem* p, vector<PCStruct>& prescribedColumns, double timeout)=0;
	std::string getTerminationInfo();
protected:
	void setTerminationInfo(std::string s);
private: 
	std::string terminationInfo;
};

#endif
