/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef COMMON_ROUTINES_H
#define COMMON_ROUTINES_H

#include "Problem.h"
#include <sstream>
#include "ChoiceEntry.h"
#include "commonStructs.h"
#include "myFPType.h"
#include "NumberListEntry.h"
#include "RowListEntry.h"

using namespace std;

Problem* constructProblemFromSStream(stringstream&);
void appendVarBoundInequations(Problem*, int);
string ReplaceString(const string &, const string &, string);
ChoiceEntry* computeChoices(unsigned int, m_entry*, sum_of_entries, sum_of_entries);
unsigned int computeChoices_recursive(unsigned int, m_entry*, sum_of_entries, sum_of_entries, ChoiceEntry*);
unsigned int twistUInt(unsigned int);
unsigned long long hashTwist(unsigned long long);
void waitSomeTime(unsigned int nanosecs);
MyFPType getBinomialCoeff(int n, int k);
NumberListEntry* getColumnList(Problem* p);
NumberListEntry* getOrderedColumnList(Problem* p);
RowListEntry* getRowList(Problem* p);
bool compareCRColumnNumberPairs(CRColumnNumberPair a, CRColumnNumberPair b);
#endif
