/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef DEFS_H
#define DEFS_H

#ifdef FOUR_BYTES_PER_ENTRY
    typedef int m_entry;
#else
    #ifdef TWO_BYTES_PER_ENTRY
	typedef short m_entry;
    #else
	typedef char m_entry;
    #endif
#endif
typedef int sum_of_entries;
typedef char inequationType;
#define IEQ_TYPE_EQ 0
#define IEQ_TYPE_GE 1
#define IEQ_TYPE_LE 2

typedef long long EVAL_TYPE;
#define INFTY_DB 1.0e300
#define INFTY_L 0x7FFFFFFF
#define INFTY_LL 0x7FFFFFFFFFFFFFFFLL
#define MINUS_INFTY_L -0x7FFFFFFF
#define MINUS_INFTY_DB -1.0e100
#define MINUS_INFTY_LL -0x7FFFFFFFFFFFFFFFLL
#define EVAL_SHIFT 1.0e14
#define NOT_DETERMINED_YET -1.0
#define PROBTABLE_NOT_RELEVANT 0x7FFFFFFF
#define NO_UPPER_BOUND 0x7FFFFFFF
#define NO_LOWER_BOUND -0x7FFFFFFF

#define ERROR_OCCURED -1
#define SOLUTION_FOUND 0
#define SEARCH_NOT_STOPPED 1
#define SEARCH_STOPPED_TIMEOUT 2

#define MINIMUM_TIME_UNIT 1.0

#ifdef _DEBUG
    #  define ASSERT(cond) { if (!(cond)) printf("file \"%s\", line %d, assertion \"" #cond "\" failed\n",__FILE__,__LINE__); }
#else
    #  define ASSERT(cond)
#endif

#ifndef LINUX
    #define NOMINMAX
#endif

#endif
