/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef EXACT_PROB_EVALUATOR
#define EXACT_PROB_EVALUATOR

#include "AbstractEvaluator.h"
#include "EvalTable.h"
#include "myFPType.h"
#include "twoDimArray.hpp"
#include "commonStructs.h"
#include <vector>
#include <map>

using namespace std;

struct RowInformation{
    RowInformation() : allEntriesNonNegative(false){}
    TwoDimArray<EvalTable> evalTable;
    TwoDimArray<int> minChange;
    TwoDimArray<int> maxChange;
    bool allEntriesNonNegative;
};

class ExactProbEvaluator : AbstractEvaluator{
public:
	ExactProbEvaluator();
	~ExactProbEvaluator();
	void freeMemory();
	void setProblem(Problem*);
	Problem* getProblem();
	EVAL_TYPE getEvaluation(unsigned int c, RowListEntry* relevantRows, unsigned int CRPhase, sum_of_entries currentCR);
	bool getRowIntervals(RowIntervalTable** rivt, bool* rivtAlloc);
private:
	void setRowInformation(RowInformation* rowInfo, sum_of_entries rowLB, sum_of_entries rowUB, unsigned int CRPhase, std::map<intpair,fppair>& terms);
	RowInformation** rowInfo;
	bool* rowInfoAllocated;
	Problem* problem;
};

#endif
