/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef MATRIX_H
#define MATRIX_H

#include "../h/Defs.h"
#include <string>
#include <stdio.h>
using namespace std;

#define MAX_ENTRY_LENGTH 11

struct Matrix{
	unsigned int cols,rows;
	m_entry* data;
	sum_of_entries* lowerBound;
	sum_of_entries* upperBound;
	Matrix() : data(NULL), lowerBound(NULL), upperBound(NULL){};
	string getAsString(){
	    char* buffer=new char[rows*cols*(MAX_ENTRY_LENGTH+10)];
	    int offset=0;
	    unsigned int r,c;
	    for (r=0; r<rows; r++){
		for (c=0; c<cols; c++){
		    offset+=sprintf(buffer+offset,"%2i ",data[c*rows+r]);
		}
		offset+=sprintf(buffer+offset," in [%2i,%2i]\n",this->lowerBound[r],this->upperBound[r]); 
	    }
	    string s(buffer);
	    delete[] buffer;
	    return s;
	}
	void clear(){
	    if (this->data!=NULL){
		delete[] this->data;
	    }
	    if (this->lowerBound!=NULL){
		delete[] this->lowerBound;
	    }
	    if (this->upperBound!=NULL){
		delete[] this->upperBound;
	    }
	}
};

#endif
