/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef NET_COMMUNICATOR_H
#define NET_COMMUNICATOR_H

#include <string>
using namespace std;

#ifdef WIN32
	#include <winsock2.h>
#endif
#ifdef LINUX
	#include <arpa/inet.h>
	#include <netdb.h>
	typedef int SOCKET;
	typedef sockaddr SOCKADDR;
	typedef sockaddr_in SOCKADDR_IN;
	#define INVALID_SOCKET -1
	#define SOCKET_ERROR -1
#endif

#define INPUT_BUFSIZE (128*1024)

class NetCommunicator{
public:
	string getFileFromIP(string,string);
	string getFileFromHost(string,string);

private:
	#ifdef WIN32
		int startWinsock();
	#endif
	void closeSocket();
	long resolveHostname(string, string&);
	void sendMessageToServer(string);
	string readDataFromServer();
	int createSocketByIP(string, int);
	int createSocketByName(string, int);

	SOCKET itsSocket;
};

#endif
