/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef POLYNOMIAL_H
#define POLYNOMIAL_H

#include "myFPType.h"

class UnivariatePolynomial{
public:
    std::vector<MyFPType> coeff;
    int degree();
    std::string asString();
};

typedef std::pair<MyFPType,intpair> BivariateMonomial;
class BivariatePolynomial{
public:
    std::vector<BivariateMonomial> monoms;
    int size();
    std::string asString();
};

UnivariatePolynomial operator* (UnivariatePolynomial& a, UnivariatePolynomial& b);
UnivariatePolynomial multiplyWithLimitedDeg (UnivariatePolynomial& a, UnivariatePolynomial& b, int maxDeg);
UnivariatePolynomial Power(UnivariatePolynomial p, unsigned int pow);
UnivariatePolynomial PowerWithLimitedDeg(UnivariatePolynomial p, unsigned int pow, int maxDeg);
UnivariatePolynomial getXTTiMinus1TTl(int i,int l);
UnivariatePolynomial PolynomDivision(UnivariatePolynomial p, UnivariatePolynomial q);
BivariatePolynomial replaceByXiYj(UnivariatePolynomial p, int i, int j);


#endif
