/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef PROBLEM_H
#define PROBLEM_H

#include "Defs.h"
#include "Matrix.h"
#include <vector>

struct Problem{
    Matrix matrix;
    m_entry* controlRow;
    sum_of_entries CRLowerBound;
    sum_of_entries CRUpperBound;
    int upperVarBound;
    unsigned int differentCREntries;
    std::vector<m_entry> CRPhaseValue;

    Problem() : upperVarBound(NO_UPPER_BOUND){}
    int getUpperVarBound();
    void setUpperVarBound(int newBound);
    string getAsString();
    void clear();
};

#endif
