/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef PROB_TABLE_H
#define PROB_TABLE_H

#include "myFPType.h"

class ProbTable{
public:
	ProbTable();
	~ProbTable();
	void freeMemory();
	void init(int l, int u, double rv_llimit=0.0, double rv_ulimit=1.0);
	double get_val(int i);
	void set_val(int i, MyFPType d);
	void add_val(int i, MyFPType d);
	int get_llimit();
	int get_ulimit();
	void normalize();
	void copy(ProbTable& a);
private:
	bool mem_allocated;
	int l_limit,u_limit;
	MyFPType* prob;
	double retval_llimit,retval_ulimit;
};

#endif
