/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef ROW_LIST_ENTRY_H
#define ROW_LIST_ENTRY_H

struct RowListEntry{
    unsigned int nr;
    RowListEntry* previousEntry;
    RowListEntry* nextEntry;
    RowListEntry* header;
    sum_of_entries correspondingLowerBound;
    sum_of_entries correspondingUpperBound;
    sum_of_entries correspondingRHS;
    sum_of_entries tempRHS;
    void removeFromList(){
	this->previousEntry->nextEntry=this->nextEntry;
	this->nextEntry->previousEntry=this->previousEntry;
    }
    void undoRemove(){
	this->previousEntry->nextEntry=this;
	this->nextEntry->previousEntry=this;
    }
    void sortToFront(){
	this->removeFromList();
	this->undoRemoveToFront();
    }
    void undoRemoveToEnd(){ //this has to be used if the order has been switched in between
	this->nextEntry=this->header;
	this->previousEntry=this->header->previousEntry;
	this->previousEntry->nextEntry=this;
	this->header->previousEntry=this;
    }
    void undoRemoveToFront(){ //this has to be used if the order has been switched in between
	this->previousEntry=this->header;
	this->nextEntry=this->header->nextEntry;
	this->nextEntry->previousEntry=this;
	this->header->nextEntry=this;
    }
};

#endif
