/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef SAMPLED_PROB_EVALUATOR
#define SAMPLED_PROB_EVALUATOR

#include "AbstractEvaluator.h"
#include "ChoiceEntry.h"
#include <map>

using namespace std;

#define DEFAULT_SAMPLE_RUNS 1000
#define DEFAULT_PAC 0.0
#define MAX_SAMPLE_COLUMNS 1000

class SampledProbEvaluator : AbstractEvaluator{
public:
	SampledProbEvaluator();
	unsigned int getSampleRuns();
	void setSampleRuns(unsigned int);
	double getPAC();
	void setPAC(double);
	void setProblem(Problem*);
	Problem* getProblem();
	EVAL_TYPE getEvaluation(unsigned int c, RowListEntry* relevantRows, unsigned int CRPhase, sum_of_entries currentCR);
	bool getRowIntervals(RowIntervalTable** rivt, bool* rivtAlloc);
private:
	unsigned int sampleRuns;
	double PAC;
	Problem* problem;
	bool hashAllocated;
	map<unsigned long long, EVAL_TYPE>* hash;
	ChoiceEntry* choiceTable;
	void clearHash();
	unsigned long long computeKey(sum_of_entries rhs, unsigned int CRPhase, sum_of_entries cr);
};

#endif
