/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef MY_FPTYPE_H
#define MY_FPTYPE_H

#include "commonStructs.h"
#include <string>

const double myFPReductionUpperMargin=1.0e150;
const double myFPReductionLowerMargin=0.000001;

class MyFPType{
    public:
	MyFPType();
	MyFPType(double v);
	MyFPType(const MyFPType& v);
	void setValueByDouble(double v);
	double getDoubleValueWithExpansion();
	double getDoubleValue() const; //the same, but without reduction check
	void expandDouble();
	MyFPType& operator+=(MyFPType b);
	MyFPType& operator-=(MyFPType b);
	MyFPType& operator*=(MyFPType b);
	MyFPType& operator/=(MyFPType b);
    private:
	double basic_value;
	int ePower;
	void normalize();
	void changeEpow(int);
	double absValue(double& a);
};

MyFPType operator+(MyFPType a, MyFPType b);
MyFPType operator-(MyFPType a, MyFPType b);
MyFPType operator*(MyFPType a, MyFPType b);
MyFPType operator/(MyFPType a, MyFPType b);

typedef std::pair<MyFPType,MyFPType> fppair;

#endif

