/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef SOLVETHREAD_H
#define SOLVETHREAD_H

#include "Thread.h"
#include "Problem.h"
#include "PCStruct.h"
#include "HeuristicSolveAlgorithm.h"

class SolveThread : private Thread{
    public:
	SolveThread();
	void solveProblem(Problem* p, vector<PCStruct>& pc, AbstractSolveAlgorithm* alg, double timeout);
	int* getSolution();
	std::string getTerminationInfo();
	bool getRunning();
    private:
	bool thread_running;
	AbstractSolveAlgorithm* thread_alg;
	int* thread_solution;
	Problem* thread_p;
	double thread_time;
	vector<PCStruct> thread_pc;
	void run();
};


#endif
