/********************************************
Copyright 2010 by Johannes Zwanzger, Bayreuth
********************************************/

#ifndef TWO_DIM_ARRAY_HPP
#define TWO_DIM_ARRAY_HPP

template<typename T>
class TwoDimArray{
public:
    TwoDimArray(){
	this->initialized=false;
	this->arr=NULL;
    };
    int init(unsigned int r, unsigned int c){
	if (this->initialized && this->arr!=NULL){
	    delete[] this->arr;
	}
	try{
	    this->arr=new T[r*c];
	}
	catch(std::bad_alloc&){
	    return -1;
	}
	this->rows=r;
	this->cols=c;
	this->initialized=true;
	return 0;
    }

    T* operator[](int row) const{
	return &this->arr[row*this->cols];
    }

    ~TwoDimArray(){
	if (this->initialized && this->arr!=NULL){
	    delete[] arr;
	}
    }

private:
    bool initialized;
    unsigned int rows, cols;
    T* arr;
};

#endif

